import { BTCImplementation } from "./chain-clients/BtcRpcImplementation";
import { DOGEImplementation } from "./chain-clients/DogeRpcImplementation";
import { XRPImplementation } from "./chain-clients/XrpRpcImplementation";
import { AlgoMccCreate, UtxoMccCreate, XrpMccCreate } from "./types";
import { ChainType, ReadRpcInterface } from "./types/genericMccTypes";
export declare type MccCreate = XrpMccCreate | AlgoMccCreate | UtxoMccCreate;
export declare module MCC {
    class BTC extends BTCImplementation implements ReadRpcInterface {
        constructor(options: UtxoMccCreate);
    }
    class DOGE extends DOGEImplementation implements ReadRpcInterface {
        constructor(options: UtxoMccCreate);
    }
    class XRP extends XRPImplementation implements ReadRpcInterface {
        constructor(options: XrpMccCreate);
    }
    function getChainType(chainIdOrName: number | string | ChainType): ChainType.invalid | ChainType.BTC | ChainType.DOGE | ChainType.XRP;
    function getChainTypeName(chainIdOrName: ChainType): "invalid" | "XRP" | "BTC" | "DOGE";
    function Client(chainIdOrName: number | string | ChainType, options: AlgoMccCreate | UtxoMccCreate | XrpMccCreate): XRP | DOGE | BTC;
}
export declare type MccClient = MCC.XRP | MCC.DOGE | MCC.BTC;
export declare type MccUtxoClient = MCC.BTC | MCC.DOGE;
//# sourceMappingURL=module.d.ts.map